Index: src/edu/ucsb/nceas/metacat/admin/SkinsAdmin.java
===================================================================
--- src/edu/ucsb/nceas/metacat/admin/SkinsAdmin.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/admin/SkinsAdmin.java	(revision 4080)
@@ -0,0 +1,224 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose:  A Class that implements skins configuration methods
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ *
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.admin;
+
+import java.io.IOException;
+import java.util.HashMap;
+import java.util.Vector;
+
+import javax.servlet.ServletException;
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+
+import org.apache.log4j.Logger;
+
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.service.SkinPropertyService;
+import edu.ucsb.nceas.metacat.util.RequestUtil;
+import edu.ucsb.nceas.metacat.util.SkinUtil;
+import edu.ucsb.nceas.utilities.PropertiesMetaData;
+import edu.ucsb.nceas.utilities.GeneralPropertyException;
+import edu.ucsb.nceas.utilities.SortedProperties;
+
+/**
+ * Control the display of the skins configuration page and the processing
+ * of the configuration values.
+ */
+public class SkinsAdmin extends MetaCatAdmin {
+
+	private static SkinsAdmin skinsAdmin = null;
+	private static Logger logMetacat = Logger.getLogger(SkinsAdmin.class);
+
+	/**
+	 * private constructor since this is a singleton
+	 */
+	private SkinsAdmin() {}
+
+	/**
+	 * Get the single instance of the MetaCatConfig.
+	 * 
+	 * @return the single instance of MetaCatConfig
+	 */
+	public static SkinsAdmin getInstance() {
+		if (skinsAdmin == null) {
+			skinsAdmin = new SkinsAdmin();
+		}
+		return skinsAdmin;
+	}
+	
+	/**
+	 * Handle configuration of the application the first time that Metacat
+	 * starts or when it is explicitly called in the url. Collect necessary
+	 * configuration information from the administrator.
+	 * 
+	 * @param request
+	 *            the http request information
+	 * @param response
+	 *            the http response to be sent back to the client
+	 */
+	public void configureSkins(HttpServletRequest request, HttpServletResponse response)
+			throws AdminException {
+
+		String processForm = request.getParameter("processForm");
+		String formErrors = (String) request.getAttribute("formErrors");
+
+		if (processForm == null || !processForm.equals("true") || formErrors != null) {
+			// The servlet configuration parameters have not been set, or there
+			// were form errors on the last attempt to configure, so redirect to
+			// the web form for configuring metacat
+			try {
+				Vector<String> skinNames = SkinUtil.getSkinNames();
+				String defaultStyle = 
+					PropertyService.getProperty("application.default-style");
+
+				request.setAttribute("defaultStyle", defaultStyle);
+				request.setAttribute("skinNameList", skinNames);
+				
+				// add skin metadata to the request.  The configuration form
+				// will use this data to determine what the configuration 
+				// fields should look like.
+				HashMap<String, PropertiesMetaData> propertyMetaData = 
+					SkinPropertyService.getMetaData();
+				request.setAttribute("metadataMap", propertyMetaData);
+				
+				// get a deep copy of properties so we can override with 
+				// backup values without changing originals
+				HashMap<String, SortedProperties> originalPropertyMap =
+					SkinPropertyService.getProperties();
+				HashMap<String, HashMap<String, String>> localPropertyMap =
+					new HashMap<String, HashMap<String, String>>();
+				HashMap<String, SortedProperties> backupPropertiesMap = 
+					SkinPropertyService.getBackupProperties();
+					
+				for (String skinName : skinNames) {
+					// first, get a deep copy of this skin's properties
+
+					SortedProperties skinProperties = originalPropertyMap.get(skinName);
+					if (skinProperties == null) {
+						throw new GeneralPropertyException("Could not find properties " 
+								+ "for skin: " + skinName);
+					}
+
+					HashMap<String, String> originalSkinProperties = 
+						skinProperties.getProperties();
+					HashMap<String, String> localSkinProperties = 
+						new HashMap<String, String>(originalSkinProperties);
+
+					// now get the backup properties for this skin.  Overwrite the 
+					// properties with backup properties.  This allows previously 
+					// set properties to be preserved in an application upgrade.
+					SortedProperties backupProperties = backupPropertiesMap.get(skinName);
+					for (String propertyName : backupProperties.getPropertyNames())
+					{
+						localSkinProperties.put(propertyName, 
+								backupProperties.getProperty(propertyName));
+					}
+								
+					localPropertyMap.put(skinName, localSkinProperties);					
+				}				
+				request.setAttribute("skinProperties", localPropertyMap);
+				
+				// Forward the request to the JSP page
+				RequestUtil.forwardRequest(request, response,
+						"/admin/skins-configuration.jsp");
+
+			} catch (GeneralPropertyException pnfe) {
+				throw new AdminException("Problem getting property while initializing "
+						+ "skins properties page: " + pnfe.getMessage());
+			} catch (IOException ioe) {
+				throw new AdminException("IO problem while initializing "
+						+ "skins properties page:" + ioe.getMessage());
+			} catch (ServletException se) {
+				throw new AdminException("problem forwarding request while "
+						+ "initializing skins properties page: " + se.getMessage());
+			}
+
+		} else {
+			// The configuration form is being submitted and needs to be
+			// processed.
+			Vector<String> processingSuccess = new Vector<String>();
+			Vector<String> processingErrors = new Vector<String>();
+			Vector<String> validationErrors = new Vector<String>();
+
+			
+			
+			
+			// Now that the options have been set, change the 'skinsConfigured'
+			// option to 'true' so that normal metacat requests will go through
+			try {
+				PropertyService.setProperty("configutil.skinsConfigured",
+						PropertyService.CONFIGURED);
+
+			} catch (IOException ioe) {
+				String errorMessage = "IO problem while processing skins "
+						+ "properties page: " + ioe.getMessage();
+				logMetacat.error(errorMessage);
+				processingErrors.add(errorMessage);
+			}
+			try {
+				if (validationErrors.size() > 0 || processingErrors.size() > 0) {
+					RequestUtil.clearRequestMessages(request);
+					RequestUtil.setRequestFormErrors(request, validationErrors);
+					RequestUtil.setRequestErrors(request, processingErrors);
+					RequestUtil.forwardRequest(request, response, "/admin");
+				} else {
+					// Now that the options have been set, change the
+					// 'skinsConfigured' option to 'true'
+					PropertyService.setProperty("configutil.skinsConfigured",
+							PropertyService.CONFIGURED);
+
+					// Reload the main metacat configuration page
+					processingSuccess.add("Skins successfully configured");
+					RequestUtil.clearRequestMessages(request);
+					RequestUtil.setRequestSuccess(request, processingSuccess);
+					RequestUtil.forwardRequest(request, response,
+							"/admin?configureType=configure&processForm=false");
+				}
+			} catch (ServletException se) {
+				throw new AdminException("problem forwarding request while "
+						+ "processing skins properties page: " + se.getMessage());
+			} catch (IOException ioe) {
+				throw new AdminException("IO problem while processing skins "
+						+ "properties page: " + ioe.getMessage());
+			}
+		}
+	}
+	
+	/**
+	 * Validate the most important configuration options submitted by the user.
+	 * 
+	 * @return a vector holding error message for any fields that fail
+	 *         validation.
+	 */
+	protected Vector<String> validateOptions(HttpServletRequest request) {
+		Vector<String> errorVector = new Vector<String>();
+
+		//TODO MCD validate options.
+
+		return errorVector;
+	}
+}
\ No newline at end of file

Index: src/edu/ucsb/nceas/metacat/admin/LDAPAdmin.java
===================================================================
--- src/edu/ucsb/nceas/metacat/admin/LDAPAdmin.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/admin/LDAPAdmin.java	(revision 4080)
@@ -0,0 +1,278 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: A Class that implements ldap configuration methods
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ *
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.admin;
+
+import java.io.IOException;
+import java.util.Set;
+import java.util.SortedMap;
+import java.util.Vector;
+
+import javax.servlet.ServletException;
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+import javax.servlet.http.HttpSession;
+
+import org.apache.log4j.Logger;
+
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.LDAPUtil;
+import edu.ucsb.nceas.metacat.util.RequestUtil;
+import edu.ucsb.nceas.metacat.util.UtilException;
+import edu.ucsb.nceas.utilities.FileUtil;
+import edu.ucsb.nceas.utilities.GeneralPropertyException;
+import edu.ucsb.nceas.utilities.MetaDataProperty;
+import edu.ucsb.nceas.utilities.PropertiesMetaData;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+import edu.ucsb.nceas.utilities.SortedProperties;
+
+/**
+ * Control the display of the LDAP configuration page and the processing
+ * of the configuration values.
+ */
+public class LDAPAdmin extends MetaCatAdmin {
+
+	private static LDAPAdmin ldapAdmin = null;
+	private static Logger logMetacat = Logger.getLogger(LDAPAdmin.class);
+
+	/**
+	 * private constructor since this is a singleton
+	 */
+	private LDAPAdmin() {}
+
+	/**
+	 * Get the single instance of the MetaCatConfig.
+	 * 
+	 * @return the single instance of MetaCatConfig
+	 */
+	public static LDAPAdmin getInstance() {
+		if (ldapAdmin == null) {
+			ldapAdmin = new LDAPAdmin();
+		}
+		return ldapAdmin;
+	}
+	
+	/**
+	 * Handle configuration of the LDAP properties
+	 * 
+	 * @param request
+	 *            the http request information
+	 * @param response
+	 *            the http response to be sent back to the client
+	 */
+	public void configureLDAP(HttpServletRequest request,
+			HttpServletResponse response) throws AdminException {
+
+		String processForm = request.getParameter("processForm");
+		String formErrors = (String) request.getAttribute("formErrors");
+
+		if (processForm == null || !processForm.equals("true") || formErrors != null) {
+			// The servlet configuration parameters have not been set, or there
+			// were form errors on the last attempt to configure, so redirect to
+			// the web form for configuring metacat
+			
+			try {
+				// Load the properties metadata file so that the JSP page can
+				// use
+				// the metadata to construct the editing form
+				PropertiesMetaData metadata = PropertyService.getOrgMetaData();
+				request.setAttribute("metadata", metadata);
+				request.setAttribute("groupMap", metadata.getGroups());
+				
+				request.setAttribute("orgList", LDAPUtil.getOrganizations());
+
+				// add the list of ldap options and their values to the request
+				Vector<String> propertyNames = PropertyService.getPropertyNamesByGroup("ldap");
+				for (String name : propertyNames) {
+					request.setAttribute(name, PropertyService.getProperty(name));
+				} 
+
+				// Check for any backup properties and apply them to the request.
+				// These are properties from previous configurations. They keep
+				// the user from having to re-enter all values when upgrading.
+				// If this is a first time install, getBackupProperties will return
+				// null.
+				SortedProperties backupProperties = PropertyService.getOrgBackupProperties();
+				if (backupProperties != null) {
+					Vector<String> backupKeys = backupProperties.getPropertyNames();
+					for (String key : backupKeys) {
+						String value = backupProperties.getProperty(key);
+						if (value != null) {
+							request.setAttribute(key, value);
+						}
+					}
+				}
+				// Forward the request to the JSP page
+				RequestUtil.forwardRequest(request, response,
+						"/admin/ldap-configuration.jsp");
+			} catch (PropertyNotFoundException pnfe) {
+				throw new AdminException("Problem getting property while initializing "
+						+ "LDAP properties page: " + pnfe.getMessage());
+			} catch (UtilException ue) {
+				throw new AdminException("Utility problem while " 
+						+ "initializing LDAP properties page: " + ue.getMessage());
+			} catch (IOException ioe) {
+				throw new AdminException("IO problem while initializing "
+						+ "LDAP properties page:" + ioe.getMessage());
+			} catch (ServletException se) {
+				throw new AdminException("problem forwarding request while " 
+						+ "initializing LDAP properties page: " + se.getMessage());
+			}
+		} else {
+			// The configuration form is being submitted and needs to be
+			// processed.
+			Vector<String> processingSuccess = new Vector<String>();
+			Vector<String> processingErrors = new Vector<String>();
+			Vector<String> validationErrors = new Vector<String>();
+
+			try {
+				// For each property, check if it is changed and save it
+				PropertiesMetaData orgMetaData = PropertyService
+						.getOrgMetaData();
+
+				// process the fields for the global options (group 1)
+				SortedMap<Integer, MetaDataProperty> globalPropertyMap = orgMetaData
+						.getPropertiesInGroup(1);
+				Set<Integer> globalPropertyIndexes = globalPropertyMap.keySet();
+				for (Integer globalPropertyIndex : globalPropertyIndexes) {
+					String globalPropertyKey = globalPropertyMap.get(
+							globalPropertyIndex).getKey();
+					PropertyService.checkAndSetProperty(request,
+							globalPropertyKey);
+				}
+
+				// process the fields for the organization options (group 2)
+				SortedMap<Integer, MetaDataProperty> orgPropertyMap = 
+						orgMetaData.getPropertiesInGroup(2);
+				Set<Integer> orgPropertyIndexes = orgPropertyMap.keySet();
+				for (String orgName : LDAPUtil.getOrganizations()) {
+					if (request.getParameter(orgName + ".cb") != null) {
+						for (Integer orgPropertyIndex : orgPropertyIndexes) {
+							String orgPropertyKey = orgPropertyMap.get(
+									orgPropertyIndex).getKey() + "." + orgName;
+							PropertyService.checkAndSetProperty(request, orgPropertyKey);
+						}
+						PropertyService.setPropertyNoPersist("ldap.configured." + orgName,
+								"true");
+					} else {
+						PropertyService.setPropertyNoPersist("ldap.configured." + orgName,
+								"false");
+					}
+				}
+
+				// we need to write the options from memory to the properties
+				// file
+				PropertyService.persistProperties();
+
+				// Validate that the options provided are legitimate. Note that
+				// we've allowed them to persist their entries. As of this point
+				// there is no other easy way to go back to the configure form
+				// and preserve their entries.
+				validationErrors.addAll(validateOptions(request));
+
+				// Try to create data file and backup directories if
+				// necessary.
+				String backupDir = PropertyService.getBackupDir();
+				if (!FileUtil.createDirectory(backupDir)) {
+					String errorString = "Could not create directory: " + backupDir;
+					logMetacat.error(errorString);
+					validationErrors.add(errorString);
+				}
+
+				// Write out the configurable properties to a backup file
+				// outside the install directory.  Note that we allow them to
+				// do this even if they have validation errors.  They will
+				// need to go back and fix the errors before they can run metacat.
+				PropertyService.persistOrgBackupProperties(request.getSession()
+						.getServletContext());
+			
+			} catch (GeneralPropertyException gpe) {
+				String errorMessage = "Problem getting or setting property while "
+					+ "processing LDAP properties page: " + gpe.getMessage();
+				logMetacat.error(errorMessage);
+				processingErrors.add(errorMessage);
+			} catch (IOException ioe) {
+				String errorMessage = "IO problem while processing LDAP "
+						+ "properties page: " + ioe.getMessage();
+				logMetacat.error(errorMessage);
+				processingErrors.add(errorMessage);
+			} catch (UtilException ue) {
+				String errorMessage = "Error in utilities while: " 
+						+ "processing LDAP properties page: " + ue.getMessage();
+				logMetacat.error(errorMessage);
+				processingErrors.add(errorMessage);
+			}
+			
+			try {
+				if (validationErrors.size() > 0 || processingErrors.size() > 0) {
+					RequestUtil.clearRequestMessages(request);
+					RequestUtil.setRequestFormErrors(request, validationErrors);
+					RequestUtil.setRequestErrors(request, processingErrors);
+					RequestUtil.forwardRequest(request, response, "/admin");
+				} else {
+					// Now that the options have been set, change the
+					// 'ldapConfigured' option to 'true'
+					PropertyService.setProperty("configutil.ldapConfigured",
+							PropertyService.CONFIGURED);
+					
+					// Reload the main metacat configuration page
+					processingSuccess.add("LDAP successfully configured");
+					RequestUtil.clearRequestMessages(request);
+					RequestUtil.setRequestSuccess(request, processingSuccess);
+					RequestUtil.forwardRequest(request, response,
+							"/admin?configureType=configure&processForm=false");
+				}
+			} catch (ServletException se) {
+				throw new AdminException("problem forwarding request while "
+						+ "processing LDAP properties page: " + se.getMessage());
+			} catch (IOException ioe) {
+				throw new AdminException("IO problem while processing LDAP "
+						+ "properties page: " + ioe.getMessage());
+			}
+		}
+	}
+	
+	/**
+	 * Validate the most important configuration options submitted by the user.
+	 * 
+	 * @return a vector holding error message for any fields that fail
+	 *         validation.
+	 */
+	protected Vector<String> validateOptions(HttpServletRequest request) {
+		Vector<String> errorVector = new Vector<String>();
+
+		//TODO MCD validate options.
+		
+//		// Test ldap connectivity
+//		String ldapError = LDAPUtil.validateLDAPConnectivity(
+//				request.getParameter("ldap.url"), request.getParameter("ldap.base"));
+//		if (ldapError != null) {
+//			errorVector.add(ldapError);
+//		}
+
+		return errorVector;
+	}
+}
\ No newline at end of file

